<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */

namespace App\Http\Services;
use App\Http\Models\ItempenggunaanbarangModel;
use App\Http\Base\BaseService;
use Illuminate\Support\Facades\DB;
class ItempenggunaanbarangService extends BaseService
{
    /**
     ItempenggunaanbarangService constructor.
    */
    public function __construct()
    {
        parent::__construct();
        $this->model= new ItempenggunaanbarangModel();
    }

	/**
	*  index function that get all data from database by default
	*  @return array|static[]
	*/
	public function index()
	{
		return $this->model->getQuery()->get();
	}


	/**
	*  this function is magic pagination injector from my library you want to add new property or field you have to inject into model in alias paging property
	*  @param array $input
	*  @return array
	*/
	public function paging($input)
	{
		$this->model->joinRelationItemId()->joinRelationPenggunaanBarangId()->getQuery()->select(["itempenggunaanbarang.id as id",
			"itemId.id as itemId",
			"itempenggunaanbarang.miNumber as miNumber",
			"itempenggunaanbarang.quantity as quantity",
			"itemId.UOM as UOM",
			"itempenggunaanbarang.lotNumber as lotNumber"
			]);
		$this->model->paging()->filter()->sorting();
		return $this->model->paging()->getPaging();
	}

	/**
	*  get one raw row data from table by id
	*  you can ad the relation like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->first()
	*  or like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->select(["aliastable.fieldname"])->first(); its mean you want to join an take spesific value
	*  and you want to take value like this $model->fieldname
	*  @param $id
	*  @return ItempenggunaanbarangModel
	*/
	public function show($id)
	{
		$model=$this->model->getQuery()->where("itempenggunaanbarang.id","=",$id)->first();
		return $model;
	}


	/**
	*  this is a base function for storing data you with transaction by default
	*  you can customization base on your business requirement as you want, you can add other object or you can to loop anc excecute the process in single process
	*  @param array $input
	*  @return ItempenggunaanbarangModel
	*  @throws \Exception
	*/
	public function store($input)
	{
		if(isset($input["itemID"]) && ! empty($input["itemID"])) {
			$newInput = $this->getPrepare($input);
			if(! empty($newInput)) {
				/* if(! $this->model->insert($newInput)) {
					throw new \Exception();
				} */
				foreach($newInput as $row) {
					$itemBrg = new ItempenggunaanbarangModel();
					$itemBrg->fill($row);
					if(! $itemBrg->save()) {
						throw new \Exception();
					}
				}
				return $this->model;
			}
		}
	}

	private function getPrepare($input) {
		$data = [];
		if(isset($input["itemID"]) && ! empty($input["itemID"])) {
			foreach($input["itemID"] as $stokID => $itemID) {
				$data[] = [	
							"miNumber" 		=> $input["miNumber"], 
							"itemId" 		=> $itemID, 
							"lotNumber" 	=> $input["lotNumber"][$stokID],
							"quantity" 		=> $input["quantity"][$stokID] /* , 
							"subInventory" 	=> $input["subInventory"][$stokID] */
				];
			}
		}
		return $data;
	}

	public function prepareReduceStock($input) {
		$data = [];
		if(isset($input["itemID"]) && ! empty($input["itemID"])) {
			foreach($input["itemID"] as $stokID => $itemID) {
				$data[] = (object) array(	
							"stokId" 	=> $input["stokID"][$stokID],
							"quantity" 	=> $input["quantity"][$stokID],
							"harga_satuan"	=> $input["harga_satuan"][$stokID],
				);
			}
		}
		return $data;
	}


	/**
	* this function will delete much data, in one action
	* the ids is a parameter from view like 1,2,3,4 and the parameter will be exploded into single array
	* you can remove this main alogorithm with your business requirement like soft delete or anything you want
	*  @param $ids
	*/
	public function delete($ids){
		$params = explode(".", $ids);
		$this->model->deleteBulk("id", $params);
	}


	/**
	*  this is a base function for update and delete data by default.
	*  you can add and custom as you want base on your requirement you can add this function as core function for handle update data from table or 
	*  you can add multiple relation proses after update in this function 
	*  @param $id
	*  @param array $input 
	*  @return ItempenggunaanbarangModel
	*  @throws \Exception
	*/
	public function update($id, $input)
	{
		$itempenggunaanbarang = ItempenggunaanbarangModel::find($id);
		// $itempenggunaanbarang->fill($input); $flight->name = 'New Flight Name';
		$itempenggunaanbarang->quantity = $input["quantity"];
		if(! $itempenggunaanbarang->save()){
			throw new \Exception();
		}
		return $itempenggunaanbarang;
	}


	/**
	*  this function will be confirting paging property into file excel
	*  the main library is base on excel spreadsheet library
	*  @param array $input
	*   @return array|static[]
	*/
	public function exportToExcel($input =array())
	{
		return $this->model->getQuery()->get();
	}

	public function showOneBasedOnPenggunaanBarang($request, $headerTransaction) {
		$auth = json_decode($request->session()->get('auth'));

		$model = $this->model->joinRelationItemId()->getQuery()
		->where("itempenggunaanbarang.miNumber", "=", $headerTransaction->miNumber)
		->where("itemId.kapalId", "=", $headerTransaction->kapalId)
		->whereIn("itemId.type_id", $auth->arrCategory)
		// ->whereIn("itempenggunaanbarang.lokasiId", $auth->arrLokasi)
		->select([	"itempenggunaanbarang.id as id",
					"itemId.namaItem as namaItem",
					"itemId.deskripsi",
					"itemId.id as itemId",
					"itemId.UOM as UOM",
					"itempenggunaanbarang.quantity as quantity",
					"itempenggunaanbarang.lotNumber as lotNumber"])->first();
		return $model;
	}

	public function showBasedOnPenggunaanBarang($request, $headerTransaction) {
		$auth = json_decode($request->session()->get('auth'));

		$model = $this->model->joinRelationItemId()->getQuery()
		->where("itempenggunaanbarang.miNumber", "=", $headerTransaction->miNumber)
		->where("itemId.kapalId", "=", $headerTransaction->kapalId)
		->whereIn("itemId.type_id", $auth->arrCategory)
		->select([	"itempenggunaanbarang.id as id",
					"itemId.namaItem as namaItem",
					"itemId.part_number as partNumber",
					"itemId.deskripsi",
					"itemId.id as itemId",
					"itemId.UOM as UOM",
					"itempenggunaanbarang.quantity as quantity",
					"itempenggunaanbarang.lotNumber as lotNumber"])->get();
		return $model;
	}

	public function getRekapitulasi($kapalId, $voyageKode, $dateStart, $dateEnd) {
		$this->model->joinRelationPenggunaanBarangId()->getQuery()
		->where("penggunaanBarangId.kapalId", "=", $kapalId)
		->where("penggunaanBarangId.voyageKode", "=", $voyageKode)
		->selectRaw(' SUM("itempenggunaanbarang"."quantity") AS "nItem", "itempenggunaanbarang"."itemId" ');
		if($voyageKode <= 0) {
			$this->model->getQuery()->whereRaw('"penggunaanBarangId"."tglPenggunaan" BETWEEN  \'' . $dateStart . '\' AND \'' . $dateEnd . '\' ');
		}
		$model = $this->model->getQuery()->groupBy("itempenggunaanbarang.itemId")
		->get();

		$arrItems = [];
		foreach($model as $row) {
			$arrItems[$row->itemId] = $row->nItem;
		}

		return $arrItems;
	}

	public function updateQty($miNumber, $itemID, $qty) {
		$itemPenggunaan = $this->model->getQuery()->where("miNumber", "=", $miNumber)->where("itemId", "=", $itemID)->first();
		if(! $itemPenggunaan){
			throw new \Exception();
		} else {
			$qty = $itemPenggunaan->quantity + $qty;
			if($qty >= 0) { } else { $qty = 0; }
			$this->update($itemPenggunaan->id, ["quantity" => $qty] );
		}		
	}

}